import React from 'react';
import * as echarts from 'echarts';
import { EChartsType } from 'echarts/types/dist/shared';
import './index.less';
import { SmEChartsProps } from './types';
export { default as ColorUtil } from './utils/color-util';
export default class SmECharts extends React.Component<SmEChartsProps, any> {
    /**
     * 可以替换 echarts 版本
     */
    static echarts: typeof echarts;
    /**
     * 默认配置项
     */
    static defaultProps: {
        type: string;
        notMerge: boolean;
        lazyUpdate: boolean;
    };
    static defaultOption: {};
    static defaultAxis: {
        grid: {
            show: boolean;
            borderColor: string;
            borderWidth: number;
        };
        xAxis: {
            show: boolean;
            type: string;
        };
        yAxis: {
            show: boolean;
            type: string;
        };
    };
    private $root;
    echartsInstance: EChartsType;
    constructor(props: SmEChartsProps);
    /**
     * 将 option 中特定项转成数组
     * @param option
     */
    private transOptionItem2Array;
    private getMergedSeries;
    private getMergedOption;
    private setChartOption;
    private handleWindowResize;
    private unbindEvents;
    private bindEvens;
    private fetchData;
    componentDidMount(): void;
    componentDidUpdate(prevProps: SmEChartsProps): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
