"use strict";

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.object.to-string.js");

require("core-js/modules/es.weak-map.js");

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.object.define-property.js");

require("core-js/modules/es.object.get-own-property-descriptor.js");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = exports.ColorUtil = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

require("core-js/modules/es.array.join.js");

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.array.for-each.js");

require("core-js/modules/web.dom-collections.for-each.js");

require("core-js/modules/es.object.keys.js");

require("core-js/modules/es.array.is-array.js");

require("core-js/modules/es.array.every.js");

require("core-js/modules/es.array.map.js");

require("core-js/modules/es.array.from.js");

require("core-js/modules/es.string.iterator.js");

require("core-js/modules/es.object.assign.js");

require("core-js/modules/es.array.some.js");

require("core-js/modules/es.array.includes.js");

require("core-js/modules/es.array.concat.js");

var _react = _interopRequireDefault(require("react"));

var echarts = _interopRequireWildcard(require("echarts"));

var _utils = require("./utils");

require("./index.less");

var _typeUtil = _interopRequireDefault(require("./utils/type-util"));

var _colorUtil = _interopRequireDefault(require("./utils/color-util"));

exports.ColorUtil = _colorUtil["default"];
var _excluded = ["series"],
    _excluded2 = ["xAxis", "yAxis"],
    _excluded3 = ["xAxis", "yAxis"],
    _excluded4 = ["className", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// lodash 递归合并
var merge = require('lodash/object/merge'); // lodash 深拷贝


var deepClone = require('lodash/lang/cloneDeep'); // lodash 节流


var throttle = require('lodash/function/throttle'); // lodash 防抖


var debounce = require('lodash/function/debounce');

var classNames = function classNames() {
  for (var _len = arguments.length, names = new Array(_len), _key = 0; _key < _len; _key++) {
    names[_key] = arguments[_key];
  }

  return names.filter(Boolean).join(' ');
};

var ResizeEvent = 'resize.chart';

var SmECharts = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2["default"])(SmECharts, _React$Component);

  /**
   * 可以替换 echarts 版本
   */

  /**
   * 默认配置项
   */
  function SmECharts(_props) {
    var _this;

    _this = _React$Component.call(this, _props) || this;
    _this.setChartOption = debounce(function () {
      var _this$echartsInstance;

      var _this$props = _this.props,
          notMerge = _this$props.notMerge,
          lazyUpdate = _this$props.lazyUpdate,
          debug = _this$props.debug,
          beforeSetOption = _this$props.beforeSetOption,
          afterSetOption = _this$props.afterSetOption;

      var option = _this.getMergedOption();

      debug && console.info('setOption', option);
      beforeSetOption === null || beforeSetOption === void 0 ? void 0 : beforeSetOption((0, _assertThisInitialized2["default"])(_this));
      (_this$echartsInstance = _this.echartsInstance) === null || _this$echartsInstance === void 0 ? void 0 : _this$echartsInstance.setOption(option, notMerge, lazyUpdate);
      afterSetOption === null || afterSetOption === void 0 ? void 0 : afterSetOption((0, _assertThisInitialized2["default"])(_this));
    }, 100);
    _this.handleWindowResize = throttle(function () {
      var _this$echartsInstance2, _this$echartsInstance3;

      (_this$echartsInstance2 = _this.echartsInstance) === null || _this$echartsInstance2 === void 0 ? void 0 : _this$echartsInstance2.clear();
      (_this$echartsInstance3 = _this.echartsInstance) === null || _this$echartsInstance3 === void 0 ? void 0 : _this$echartsInstance3.resize();

      _this.setChartOption();
    }, 67);

    _this.unbindEvents = function (props) {
      Object.keys(props.onEvents || {}).forEach(function (eventName) {
        var _this$echartsInstance4;

        return (_this$echartsInstance4 = _this.echartsInstance) === null || _this$echartsInstance4 === void 0 ? void 0 : _this$echartsInstance4.off(eventName);
      });
    };

    _this.bindEvens = function () {
      var events = _this.props.onEvents || {};
      var isDebug = _this.props.debug;

      var bindEvent = function bindEvent(eventName, handler) {
        if (typeof handler === 'function') {
          var _this$echartsInstance5;

          isDebug && console.info('绑定事件', eventName);
          (_this$echartsInstance5 = _this.echartsInstance) === null || _this$echartsInstance5 === void 0 ? void 0 : _this$echartsInstance5.on(eventName, handler);
        } else if (Array.isArray(handler) && handler.length === 2) {
          var _this$echartsInstance6;

          var query = handler[0],
              eventHandler = handler[1];
          isDebug && console.info('绑定事件', eventName, query);
          (_this$echartsInstance6 = _this.echartsInstance) === null || _this$echartsInstance6 === void 0 ? void 0 : _this$echartsInstance6.on(eventName, query, eventHandler);
        }
      };

      Object.keys(events).forEach(function (eventName) {
        var handler = events[eventName];

        if (Array.isArray(handler)) {
          if (handler.length === 2 && handler.every(function (item) {
            return !Array.isArray(item);
          }) && (_typeUtil["default"].isPlainObject(handler[0]) || _typeUtil["default"].isString(handler[0])) && typeof handler[1] === 'function') {
            // @ts-ignore
            bindEvent(eventName, handler);
          } else {
            handler.forEach(function (eventHandler) {
              return bindEvent(eventName, eventHandler);
            });
          }
        } else if (typeof handler === 'function') {
          bindEvent(eventName, handler);
        }
      });
    };

    _this.state = {
      data: []
    };
    return _this;
  }
  /**
   * 将 option 中特定项转成数组
   * @param option
   */


  var _proto = SmECharts.prototype;

  _proto.transOptionItem2Array = function transOptionItem2Array(option) {
    var newOption = deepClone(option);
    ['legend', 'grid', 'xAxis', 'yAxis', 'geo', 'series', 'tooltip'].forEach(function (key) {
      if (newOption !== null && newOption !== void 0 && newOption[key] && !Array.isArray(newOption[key])) {
        newOption[key] = [newOption[key]];
      }
    });
    return newOption;
  };

  _proto.getMergedSeries = function getMergedSeries() {
    var _this$props$data;

    var _this$props2 = this.props,
        _this$props2$option = _this$props2.option,
        option = _this$props2$option === void 0 ? {} : _this$props2$option,
        series = _this$props2.series,
        multi = _this$props2.multi,
        type = _this$props2.type;
    var data = (_this$props$data = this.props.data) !== null && _this$props$data !== void 0 ? _this$props$data : this.state.data;
    var dataArr = Array.isArray(type) || multi ? data : [data];
    var types = Array.isArray(type) ? type : [type];

    if (multi && types.length === 1 && dataArr.length > 1) {
      types = Array.from({
        length: dataArr.length
      }).map(function () {
        return types[0];
      });
    } // @ts-ignore


    var mergedSeries = types.map(function (type, i) {
      return {
        type: type,
        data: dataArr[i] || []
      };
    });
    [option === null || option === void 0 ? void 0 : option.series, series].filter(Boolean).forEach(function (series) {
      if (Array.isArray(series)) {
        mergedSeries = merge([], mergedSeries, series);
      } else if (typeof series === 'object') {
        // @ts-ignore
        mergedSeries = mergedSeries.map(function (item) {
          return Object.assign({}, item, series);
        });
      }
    });
    return mergedSeries;
  };

  _proto.getMergedOption = function getMergedOption() {
    var _this$props3 = this.props,
        _this$props3$option = _this$props3.option,
        option = _this$props3$option === void 0 ? {} : _this$props3$option,
        type = _this$props3.type,
        grid = _this$props3.grid,
        legend = _this$props3.legend,
        geo = _this$props3.geo,
        xAxis = _this$props3.xAxis,
        yAxis = _this$props3.yAxis,
        rotateAxis = _this$props3.rotateAxis,
        tooltip = _this$props3.tooltip,
        category = _this$props3.category;
    var _ = option.series,
        others = (0, _objectWithoutPropertiesLoose2["default"])(option, _excluded);
    var mergedSeries = this.getMergedSeries();
    var types = Array.isArray(type) ? type : [type];
    var defaultOption = deepClone(SmECharts.defaultOption); // 需要坐标轴的图表
    // line,bar,scatter,effectScatter,pictorialBar(象形图),
    // boxplot(箱形图),candlestick(k线图),heatmap(热力图),custom

    if (types.some(function (type) {
      return ['line', 'bar', 'scatter', 'effectScatter', 'pictorialBar', 'boxplot', 'candlestick', 'heatmap', 'custom'].includes(type);
    })) {
      var _ref2, _ref3, _ref4;

      var _SmECharts$defaultAxi = SmECharts.defaultAxis,
          _SmECharts$defaultAxi2 = _SmECharts$defaultAxi.xAxis,
          _xAxis = _SmECharts$defaultAxi2 === void 0 ? {} : _SmECharts$defaultAxi2,
          _SmECharts$defaultAxi3 = _SmECharts$defaultAxi.yAxis,
          _yAxis = _SmECharts$defaultAxi3 === void 0 ? {} : _SmECharts$defaultAxi3,
          defaultAxis = (0, _objectWithoutPropertiesLoose2["default"])(_SmECharts$defaultAxi, _excluded2);

      var _defaultOption = defaultOption,
          _defaultOption$xAxis = _defaultOption.xAxis,
          x = _defaultOption$xAxis === void 0 ? {} : _defaultOption$xAxis,
          _defaultOption$yAxis = _defaultOption.yAxis,
          y = _defaultOption$yAxis === void 0 ? {} : _defaultOption$yAxis,
          _option = (0, _objectWithoutPropertiesLoose2["default"])(_defaultOption, _excluded3);

      var _ref = rotateAxis ? ['yAxis', 'xAxis'] : ['xAxis', 'yAxis'],
          xa = _ref[0],
          ya = _ref[1]; // 合并坐标轴相关默认配置


      defaultOption = merge.apply(void 0, [{}].concat([(_ref2 = {}, _ref2[xa] = _xAxis, _ref2[ya] = _yAxis, _ref2), (_ref3 = {}, _ref3[xa] = x, _ref3[ya] = y, _ref3), defaultAxis, _option, Array.isArray(category) && (_ref4 = {}, _ref4[xa] = {
        data: category
      }, _ref4)].filter(Boolean)));
    }

    return merge.apply(void 0, [{}].concat([defaultOption, others, {
      legend: legend,
      grid: grid,
      xAxis: xAxis,
      yAxis: yAxis,
      geo: geo,
      tooltip: tooltip
    }, {
      series: mergedSeries
    }].map(this.transOptionItem2Array)));
  };

  _proto.fetchData = /*#__PURE__*/function () {
    var _fetchData = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var data;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!this.props.fetchData) {
                _context.next = 11;
                break;
              }

              _context.prev = 1;
              _context.next = 4;
              return this.props.fetchData();

            case 4:
              data = _context.sent;
              this.setState({
                data: data || []
              });
              _context.next = 11;
              break;

            case 8:
              _context.prev = 8;
              _context.t0 = _context["catch"](1);
              console.error(_context.t0.message);

            case 11:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 8]]);
    }));

    function fetchData() {
      return _fetchData.apply(this, arguments);
    }

    return fetchData;
  }();

  _proto.componentDidMount = function componentDidMount() {
    var _this$props4, _this$props4$onInit;

    // @ts-ignore
    this.echartsInstance = SmECharts.echarts.init(this.$root);
    (_this$props4 = this.props) === null || _this$props4 === void 0 ? void 0 : (_this$props4$onInit = _this$props4.onInit) === null || _this$props4$onInit === void 0 ? void 0 : _this$props4$onInit.call(_this$props4, this);
    this.setChartOption();
    this.bindEvens(); // 监听resize

    _utils.EventUtil.addEventListener(ResizeEvent, this.handleWindowResize);

    this.fetchData();
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    this.setChartOption();
    this.unbindEvents(prevProps);
    this.bindEvens();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var _this$props$onDestroy, _this$props5, _this$echartsInstance7;

    // 移除监听resize
    _utils.EventUtil.removeEventListener(ResizeEvent, this.handleWindowResize);

    this.unbindEvents(this.props);
    (_this$props$onDestroy = (_this$props5 = this.props).onDestroy) === null || _this$props$onDestroy === void 0 ? void 0 : _this$props$onDestroy.call(_this$props5, this); // 销毁

    (_this$echartsInstance7 = this.echartsInstance) === null || _this$echartsInstance7 === void 0 ? void 0 : _this$echartsInstance7.dispose();
  };

  _proto.render = function render() {
    var _this2 = this;

    var _this$props6 = this.props,
        className = _this$props6.className,
        style = _this$props6.style,
        others = (0, _objectWithoutPropertiesLoose2["default"])(_this$props6, _excluded4); // 外部传入的 dom events

    var domEvents = {};
    Object.keys(others).forEach(function (key) {
      // @ts-ignore
      /^on[CDM][lor]/.test(key) && (domEvents[key] = others[key]);
    });
    return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
      ref: function ref(el) {
        return _this2.$root = el;
      },
      style: style,
      className: classNames('sm-echarts', className)
    }, domEvents));
  };

  return SmECharts;
}(_react["default"].Component);

exports["default"] = SmECharts;
SmECharts.echarts = echarts;
SmECharts.defaultProps = {
  type: 'line',
  notMerge: false,
  lazyUpdate: false
};
SmECharts.defaultOption = {};
SmECharts.defaultAxis = {
  // 坐标系
  grid: {
    show: true,
    borderColor: 'transparent',
    borderWidth: 0
  },
  // x轴
  xAxis: {
    show: true,
    type: 'category'
  },
  // y轴
  yAxis: {
    show: true,
    type: 'value'
  }
};